Skip to content

Introduction

The Hypatos API is organized around REST. The majority of the endpoints provide CRUD functionality for resources. The API is also exposing Intent Resources which mimic user intents or actions.

The Hypatos API uses OAuth 2.0 Client Credential Grant to authenticate requests. Before making any requests to any endpoint a client must authenticate with the authorization server and requests an access token from the token endpoint.

  POST /auth/token HTTP/1.1
  Host: api.cloud.hypatos.ai
  Content-Type: application/x-www-form-urlencoded
  Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=

  grant_type=client_credentials

Authorization header contains client_id:client_secret encoded as explained in RFC Client Password section.

If the authorization server authenticated the client successfully, an access token is issued. Here is an example successful response:

  HTTP/1.1 200 OK
  Content-Type: application/json;charset=UTF-8
  Cache-Control: no-store
  Pragma: no-cache

  {
    "access_token": "mF_9.B5f-4.1JqM",
    "expires_in": 86400,
    "scope": "enrichment.write files.read",
    "token_type": "Bearer",
  }

This token can be used to authenticate the requests to API endpoints by sending a Bearer token in the Authorization HTTP header. The following example demonstrates how to use the access token to retrieve a list of documents.

  GET /v2/documents HTTP/1.1
  Host: api.cloud.hypatos.ai
  Authorization: Bearer mF_9.B5f-4.1JqM

Versioning

Changes to this API are released regularly. We use Semantic Versioning 2.0.0 scheme for versioning so that the clients can identify any backward-incompatible changes easily. Briefly summarized one can say, if the MAJOR version of the new API version didn't change you can expect the new version to be backward-compatible.

Rate limits

In order to maximise the stability of our API, we institue rate limits for all of API endpoints. Clients who send too many requests over a given period of time will see error responses that show up as status code 429 Too Many Requests.

When you see error responses with status code 429, it means you exhausted your current quota and need to withhold from sending further requests until the quota is reset. We encourage you not to wait until you get a 429 error but to monitor your quota in each request. In each response you receive from the API, you will find HTTP headers providing the details about your current quota. Here is the list of the HTTP headers:

  • x-ratelimit-limit: Indicates the quota associated to the client in the current time-window followed by the description of the quota policy.
  • x-ratelimit-remaining: Indicates the number of remaining requests in the current time-window
  • x-ratelimit-reset: Indicates the number of seconds until quota reset of the current time-window

Please note that IETF is currently in the process of publishing a standard for these headers. Please explore the draft for more details.

A basic technique to gracefully handle rate limits is watch for your quota permanently and increase the time between your request as the quota is decreasing. To recover from a 429 error you need a retry mechanism following an exponential backoff schedule.

Download OpenAPI description
Overview
License
Languages
Servers
API EU
https://api.cloud.hypatos.ai/v2
API US
https://api.cloud.hypatos.com/v2
Mock server
https://hypatos.redocly.app/_mock/openapi
Operations

Endpoints for management of files

Operations

Endpoints for document management

Operations

Endpoints for data enrichment

Operations

Request

Security
OAuth2(Required scopes:
enrichment.delete
)
Path
externalIdstringrequired

Previously sent externalId

curl -i -X DELETE \
  'https://api.cloud.hypatos.ai/v2/enrichment/sales-orders/{externalId}' \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>'

Responses

Successfully deleted

Response
No content

Request

Security
OAuth2(Required scopes:
enrichment.write
)
Bodyapplication/jsonrequired
externalIdstring^\S+$required

External ID of the product that is globally unique across the provided product data

Example: "DE01"
externalClientIdstring

Identifier of the client entity in the source system which can be used to separate data

Example: "EXTERNAL_CLIENT_ID"
productNumberstring

Number of the product as defined by the supplier

Example: "NO123"
typestring

Type of the product as defined in the company’s product master (e.g., Operating Supplies)

Example: "Operating Supplies"
groupstring

Group of the product as defined in the product master of the company

Example: "Electronics"
descriptionstring

Description of the product

Example: "A Laptop XP"
shortDescriptionstring

Shortened version of the product description

Example: "A great laptop"
manufacturerstring

Name of the product manufacturer

Example: "Corporation ABC"
unspscstring

Universal Product Code (UPC-A)

Example: "43211508"
eanstring

European Article Number (EAN-13)

Example: "4006381333931"
upcstring

Universal Product Code (UPC-A)

Example: "036000291452"
baseUnitOfMeasurestring

The base unit in which the product is managed in the system

Example: "kg"
customsTariffNumberstring

Customs tariff number (HS/TARIC code) used for cross-border trade and customs

Example: "8471300000"
plantsArray of strings
Example: ["PLANT-001"]
statusstring

Current status of the product

Enum"ACTIVE""INACTIVE""DISCONTINUED"
Example: "ACTIVE"
grossWeightnumber

Gross weight of the product including packaging

Example: 2.5
netWeightnumber

Net weight of the product excluding packaging

Example: 2.3
weightUnitstring

Unit for weight values

Example: "KG"
volumenumber

Volume of the product

Example: 0.015
volumeUnitstring

Unit for volume values

Example: "M3"
salesOrganizationInfoArray of objects(productSalesOrganizationInfo)
customFieldsobject(customFields)

List of key value pairs containing custom fields from the source system

customMetadataobject(JsonObject)

Any nested structure with metadata that source system needs to send

Example: {"someTopLevelProperty":"value1","someNestedProperty":{"nestedProperty":"value2"},"someArrayProperty":["value3","value4"]}
curl -i -X POST \
  https://api.cloud.hypatos.ai/v2/enrichment/products \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
  -H 'Content-Type: application/json' \
  -d '{
    "externalId": "DE01",
    "externalClientId": "EXTERNAL_CLIENT_ID",
    "productNumber": "NO123",
    "type": "Operating Supplies",
    "group": "Electronics",
    "description": "A Laptop XP",
    "shortDescription": "A great laptop",
    "manufacturer": "Corporation ABC",
    "unspsc": "43211508",
    "ean": "4006381333931",
    "upc": "036000291452",
    "baseUnitOfMeasure": "kg",
    "customsTariffNumber": "8471300000",
    "plants": [
      "PLANT-001"
    ],
    "status": "ACTIVE",
    "grossWeight": 2.5,
    "netWeight": 2.3,
    "weightUnit": "KG",
    "volume": 0.015,
    "volumeUnit": "M3",
    "salesOrganizationInfo": [
      {
        "externalSalesOrganizationId": "1000",
        "distributionChannel": "2000",
        "division": "3000",
        "salesGroup": "4000",
        "salesOffice": "5000",
        "blockedForOrdering": true,
        "blockedForDelivery": false,
        "shippingAddresses": [
          "ADDR001",
          "ADDR002"
        ],
        "billingAddresses": [
          "ADDR003"
        ],
        "salesOrganizationCode": "SO001",
        "salesUnit": {
          "unitOfMeasure": "PK",
          "conversionFactorToBaseUnit": 1000,
          "description": "Package of 10 units"
        },
        "productGroup1": "ELECTRONICS",
        "productGroup2": "COMPUTERS",
        "productGroup3": "LAPTOPS",
        "productGroup4": "B2B_DIRECT",
        "productGroup5": "B2B_DIRECT",
        "productCategoryGroup": "STANDARD_GOOD"
      }
    ],
    "customFields": {
      "property1": "string",
      "property2": "string"
    },
    "customMetadata": {
      "someTopLevelProperty": "value1",
      "someNestedProperty": {
        "nestedProperty": "value2"
      },
      "someArrayProperty": [
        "value3",
        "value4"
      ]
    }
  }'

Responses

Successfully inserted

Bodyapplication/json
idstringrequired
Example: "3a429dc8-56d4-42ef-a4cf-2ebc9ad1ef38"
Response
application/json
{ "id": "3a429dc8-56d4-42ef-a4cf-2ebc9ad1ef38" }

Request

Security
OAuth2(Required scopes:
enrichment.write
)
Path
externalIdstringrequired

Previously sent externalId

Bodyapplication/merge-patch+jsonrequired
externalIdstring^\S+$required

External ID of the product that is globally unique across the provided product data

Example: "DE01"
externalClientIdstring

Identifier of the client entity in the source system which can be used to separate data

Example: "EXTERNAL_CLIENT_ID"
productNumberstring

Number of the product as defined by the supplier

Example: "NO123"
typestring

Type of the product as defined in the company’s product master (e.g., Operating Supplies)

Example: "Operating Supplies"
groupstring

Group of the product as defined in the product master of the company

Example: "Electronics"
descriptionstring

Description of the product

Example: "A Laptop XP"
shortDescriptionstring

Shortened version of the product description

Example: "A great laptop"
manufacturerstring

Name of the product manufacturer

Example: "Corporation ABC"
unspscstring

Universal Product Code (UPC-A)

Example: "43211508"
eanstring

European Article Number (EAN-13)

Example: "4006381333931"
upcstring

Universal Product Code (UPC-A)

Example: "036000291452"
baseUnitOfMeasurestring

The base unit in which the product is managed in the system

Example: "kg"
customsTariffNumberstring

Customs tariff number (HS/TARIC code) used for cross-border trade and customs

Example: "8471300000"
plantsArray of strings
Example: ["PLANT-001"]
statusstring

Current status of the product

Enum"ACTIVE""INACTIVE""DISCONTINUED"
Example: "ACTIVE"
grossWeightnumber

Gross weight of the product including packaging

Example: 2.5
netWeightnumber

Net weight of the product excluding packaging

Example: 2.3
weightUnitstring

Unit for weight values

Example: "KG"
volumenumber

Volume of the product

Example: 0.015
volumeUnitstring

Unit for volume values

Example: "M3"
salesOrganizationInfoArray of objects(productSalesOrganizationInfo)
customFieldsobject(customFields)

List of key value pairs containing custom fields from the source system

customMetadataobject(JsonObject)

Any nested structure with metadata that source system needs to send

Example: {"someTopLevelProperty":"value1","someNestedProperty":{"nestedProperty":"value2"},"someArrayProperty":["value3","value4"]}
curl -i -X PATCH \
  'https://api.cloud.hypatos.ai/v2/enrichment/products/{externalId}' \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
  -H 'Content-Type: application/merge-patch+json' \
  -d '{
    "externalId": "DE01",
    "externalClientId": "EXTERNAL_CLIENT_ID",
    "productNumber": "NO123",
    "type": "Operating Supplies",
    "group": "Electronics",
    "description": "A Laptop XP",
    "shortDescription": "A great laptop",
    "manufacturer": "Corporation ABC",
    "unspsc": "43211508",
    "ean": "4006381333931",
    "upc": "036000291452",
    "baseUnitOfMeasure": "kg",
    "customsTariffNumber": "8471300000",
    "plants": [
      "PLANT-001"
    ],
    "status": "ACTIVE",
    "grossWeight": 2.5,
    "netWeight": 2.3,
    "weightUnit": "KG",
    "volume": 0.015,
    "volumeUnit": "M3",
    "salesOrganizationInfo": [
      {
        "externalSalesOrganizationId": "1000",
        "distributionChannel": "2000",
        "division": "3000",
        "salesGroup": "4000",
        "salesOffice": "5000",
        "blockedForOrdering": true,
        "blockedForDelivery": false,
        "shippingAddresses": [
          "ADDR001",
          "ADDR002"
        ],
        "billingAddresses": [
          "ADDR003"
        ],
        "salesOrganizationCode": "SO001",
        "salesUnit": {
          "unitOfMeasure": "PK",
          "conversionFactorToBaseUnit": 1000,
          "description": "Package of 10 units"
        },
        "productGroup1": "ELECTRONICS",
        "productGroup2": "COMPUTERS",
        "productGroup3": "LAPTOPS",
        "productGroup4": "B2B_DIRECT",
        "productGroup5": "B2B_DIRECT",
        "productCategoryGroup": "STANDARD_GOOD"
      }
    ],
    "customFields": {
      "property1": "string",
      "property2": "string"
    },
    "customMetadata": {
      "someTopLevelProperty": "value1",
      "someNestedProperty": {
        "nestedProperty": "value2"
      },
      "someArrayProperty": [
        "value3",
        "value4"
      ]
    }
  }'

Responses

Successfully updated

Bodyapplication/json
externalIdstring^\S+$required

External ID of the product that is globally unique across the provided product data

Example: "DE01"
externalClientIdstring

Identifier of the client entity in the source system which can be used to separate data

Example: "EXTERNAL_CLIENT_ID"
productNumberstring

Number of the product as defined by the supplier

Example: "NO123"
typestring

Type of the product as defined in the company’s product master (e.g., Operating Supplies)

Example: "Operating Supplies"
groupstring

Group of the product as defined in the product master of the company

Example: "Electronics"
descriptionstring

Description of the product

Example: "A Laptop XP"
shortDescriptionstring

Shortened version of the product description

Example: "A great laptop"
manufacturerstring

Name of the product manufacturer

Example: "Corporation ABC"
unspscstring

Universal Product Code (UPC-A)

Example: "43211508"
eanstring

European Article Number (EAN-13)

Example: "4006381333931"
upcstring

Universal Product Code (UPC-A)

Example: "036000291452"
baseUnitOfMeasurestring

The base unit in which the product is managed in the system

Example: "kg"
customsTariffNumberstring

Customs tariff number (HS/TARIC code) used for cross-border trade and customs

Example: "8471300000"
plantsArray of strings
Example: ["PLANT-001"]
statusstring

Current status of the product

Enum"ACTIVE""INACTIVE""DISCONTINUED"
Example: "ACTIVE"
grossWeightnumber

Gross weight of the product including packaging

Example: 2.5
netWeightnumber

Net weight of the product excluding packaging

Example: 2.3
weightUnitstring

Unit for weight values

Example: "KG"
volumenumber

Volume of the product

Example: 0.015
volumeUnitstring

Unit for volume values

Example: "M3"
salesOrganizationInfoArray of objects(productSalesOrganizationInfo)
customFieldsobject(customFields)

List of key value pairs containing custom fields from the source system

customMetadataobject(JsonObject)

Any nested structure with metadata that source system needs to send

Example: {"someTopLevelProperty":"value1","someNestedProperty":{"nestedProperty":"value2"},"someArrayProperty":["value3","value4"]}
Response
application/json
{ "externalId": "DE01", "externalClientId": "EXTERNAL_CLIENT_ID", "productNumber": "NO123", "type": "Operating Supplies", "group": "Electronics", "description": "A Laptop XP", "shortDescription": "A great laptop", "manufacturer": "Corporation ABC", "unspsc": "43211508", "ean": "4006381333931", "upc": "036000291452", "baseUnitOfMeasure": "kg", "customsTariffNumber": "8471300000", "plants": [ "PLANT-001" ], "status": "ACTIVE", "grossWeight": 2.5, "netWeight": 2.3, "weightUnit": "KG", "volume": 0.015, "volumeUnit": "M3", "salesOrganizationInfo": [ { … } ], "customFields": { "property1": "string", "property2": "string" }, "customMetadata": { "someTopLevelProperty": "value1", "someNestedProperty": { … }, "someArrayProperty": [ … ] } }

Endpoints for company management

Operations

Endpoints for project management

Operations

Endpoints for e-invoices

Operations

Endpoints serving project-scoped documents as XML

Operations
Operations
Operations
Operations